/*

*/



/**
   A simple generic Stack abstract data type.
   <p>
   Here is the Stack interface.
      int     size()              <br>
      E       peek()              <br>
      E       pop()               <br>
      void    push(E element)     <br>
      boolean isEmpty()           <br>
*/
public abstract class Stack<T>
{
   /**
      Returns the number of items currently in this {@code Stack}.

      @return the number of items in this {@code Stack}
   */
   public abstract int size();


   /**
      Returns true if this {@code Stack} does not conatin any items.

      @return true if there are no items in this {@code Stack}
   */
   public boolean isEmpty()
   {
      return 0 == size();
   }


   /**
      Return the item at the top of this {@code Stack}.

      @return a reference to the item at the top of this {@code Stack}
   */
   public abstract T peek();


   /**
      Remove the item at the top of this {@code Stack}.
      The {@code Stack} size decreases by one.

      @return a reference to the item that was removed from the top of this {@code Stack}
   */
   public abstract T pop();


   /**
      Insert the item at the top of this {@code Stack}.
      The {@code Stack} size increases by one.

      @param element  reference to the item to be added to the top of this {@code Stack}
   */
   public abstract void push(T element);


   /**
      Return a {@link String} representation of this {@code Stack}.

      @return {@link String} representation of this {@code Stack}
   */
   @Override
   public abstract String toString();

}//Stack
