/*

*/



/**
   A simple generic implementation of the Stack abstract data type
   that uses a LinkedList implementation.
   <p>
   Here is the Stack interface.
      E     peek()              <br>
      E     pop()               <br>
      void  push(E element)     <br>
*/
public class LinkedStack<E> extends LinkedList<E> implements Stack<E>
{
   private List<E> stack;

   /**
      Default constructor creates an empty stack.
   */
   public LinkedStack()
   {
      super();
   }


   /**
      Return the item at the top of this {@code Stack}.
      <p>
      The top of the stack is at the front of the list.

      @return a reference to the item at the top of this {@code Stack}
   */
   @Override
   public E peek()
   {
      return this.get(0);
   }


   /**
      Remove the item at the top of this {@code Stack}.
      The {@code Stack} size decreases by one.
      <p>
      The top of the stack is at the front of the list.

      @return a reference to the item that was removed from the top of this {@code Stack}
   */
   @Override
   public E pop()
   {
      return this.remove(0);
   }


   /**
      Insert the item at the top of this {@code Stack}.
      The {@code Stack} size increases by one.
      <p>
      The top of the stack is at the front of the list.

      @param element  reference to the item to be added to the top of this {@code Stack}
   */
   @Override
   public void push(E element)
   {
      this.add(0, element);
   }

}//LinkedStack
