/*

*/



/**
   A simple generic Stack interface.
   <p>
   Here is the Stack interface.
      E     peek()              <br>
      E     pop()               <br>
      void  push(E element)     <br>
*/
public interface Stack<T>
{
   /**
      Return the item at the top of this {@code Stack}.

      @return a reference to the item at the top of this {@code Stack}
   */
   public abstract T peek();


   /**
      Remove the item at the top of this {@code Stack}.
      The {@code Stack} size decreases by one.

      @return a reference to the item that was removed from the top of this {@code Stack}
   */
   public abstract T pop();


   /**
      Insert the item at the top of this {@code Stack}.
      The {@code Stack} size increases by one.

      @param element  reference to the item to be added to the top of this {@code Stack}
   */
   public abstract void push(T element);

}//Stack
