/**
   https://people.scs.carleton.ca/~lanthier/teaching/COMP1406/Notes/Code/Chapter8/BracketMatchTestProgram.java
*/
import java.util.*;

public class BracketMatchTestProgram
{
   public static boolean bracketsMatch(String s)
   {
      Stack<Character> stack = new ArrayStack<>();

      for (int i = 0; i < s.length(); ++i)
      {
         char c = s.charAt(i);

         if ( c == '('
           || c == '['
           || c == '{' )  // got open bracket
         {
            stack.push(c);
         }

         if ( c == ')'
           || c == ']'
           || c == '}' )  // got close bracket
         {
            if (stack.isEmpty())
               return false;  // no open bracket for this closed one

            char top = stack.pop(); // get the last opening bracket found
            if ( (c == ')' && top != '(')
              || (c == ']' && top != '[')
              || (c == '}' && top != '{') )
            {
               return false;  // wrong closing bracket for last opened one
            }
         }
      }
      return stack.isEmpty();  // no match if brackets are left over
   }


   public static void main(String[] args)
   {
      Scanner keyboard = new Scanner(System.in);
      String aString;
      do
      {
         System.out.println("Please enter expression: (<cr> to quit)");
         aString = keyboard.nextLine();

         if (bracketsMatch(aString))
            System.out.println("The brackets match");
         else
            System.out.println("The brackets do not match");
      } while (aString.length() > 0);
   }
}
